﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace igTreeGridLOD.Controllers
{
	public class HomeController : Controller
	{
		static int _level = 1;

		public ActionResult Index()
		{
			return View();
		}

		public ActionResult About()
		{
			ViewBag.Message = "Your application description page.";

			return View();
		}

		public ActionResult Contact()
		{
			ViewBag.Message = "Your contact page.";

			return View();
		}

		[HttpGet]
		public JsonResult GetMyData(string pk, string propertyDataLevel, string propertyExpanded, string childDataKey, int initialExpandDepth, string targetDate)
		{
			var items = new List<MyItem>();

			try
			{

				DateTime d;
				if (!DateTime.TryParse(targetDate, out d))
				{
					d = DateTime.Now;
				}

				for (char c = 'A'; c < 'G'; ++c)
				{
					var s = String.Empty.PadRight(_level, c);
					items.Add(new MyItem()
					{
						Key = s,
						Description = s,
						Value = c
					});
				}

				++_level;

				return Json(items, JsonRequestBehavior.AllowGet);
			}
			catch (Exception oException)
			{
				return Json(new { success = false, error = oException.ToString(), items = items }, JsonRequestBehavior.AllowGet);
			}
		}

		public class MyItem
		{
			public string Key { get; set; }
			public string Description { get; set; }
			public decimal Value { get; set; }
			public List<MyItem> Items { get; set; }

			public MyItem()
			{
				Items = new List<MyItem>();
			}
		}
	}
}